﻿view.caption = strTitle;
view.resizeTo(200, view.width);
contentArea.contentFlags = gddContentFlagHaveDetails;



var alert = storage.openText("alert.xml");

// default/initial settings
options.defaultValue("feed_0") = "http://feeds.reuters.com/reuters/worldNews";
options.defaultValue("feed_1") = "http://feeds.reuters.com/reuters/topNews";
options.defaultValue("feed_2") = "http://feeds.reuters.com/reuters/scienceNews";
options.defaultValue("feed_3") = "http://feeds.reuters.com/reuters/domesticNews";

var CURRENT_LOC = null;
var itemImage = graphics.loadImage("nasa_earth_xl.jpg");
var imageHeight = 4096;
var imageWidth = 8192;

var target_image = graphics.loadImage("exclam.gif");
var info_image = graphics.loadImage("infobox.gif");

var description = null;

var past_news = new Array();

var iFeedNum = 0;
var iStory = 0;

var xTop = 0;
var yTop = 0;

var timerFailCount = 0;

//variable to hold remainders if window is to small to scroll 1 pixel per second
var tic = 0;

var zoom = 15;

var city_list = storage.openText("cities.csv");
city_list = city_list.toLowerCase();

var map = new ContentItem();

var focused = null;

var moveDone = false;


///////////////////////////

LoadMap();
//setInterval(OnTimer, 1000 * 10);  // check once every twenty seconds
setTimeout(OnTimer, 1000*10);
//OnTimer();    // update with first set of items

//setInterval(mapIdle, 10);

function LoadMap()
{
	focused = null;
	//clear the window
	contentArea.removeAllContentItems();
	
	//create a new item to hold the map
	xTop = -200;
	yTop = -200;
	zoom = 5;
	map.heading = "World Map";
	map.snippet = "";
	map.onDetailsView = OnDetailsView;


	map.flags = gddItemDisplayInSidebar;

	map.SetRect(0, 0, plugin.window_width, plugin.window_height);
	map.onDrawItem = DrawItem;
	

	contentArea.addContentItem(map, gddItemDisplayInSidebar);
	
}

function DrawItem(item, target, graphics, x, y, width, height) 
{
	
	var cWidth = plugin.window_width*zoom;
	var cHeight = cWidth/2;

	var xCord = x - plugin.window_width/2;
  	graphics.DrawImage(xTop, yTop, cWidth, cHeight, itemImage, 100);

	if(xTop > 0)
	{
		graphics.DrawImage(xTop-cWidth, yTop, cWidth, cHeight, itemImage, 100);
	}

}

function DrawTarget(item, target, graphics, x, y, width, height) 
{
	var cWidth = plugin.window_width*zoom;
	var cHeight = cWidth/2;

	var tX = parseInt(plugin.window_width/2)-10;
	var tY = parseInt(plugin.window_height/2)-10;
	
	graphics.DrawImage(xTop, yTop, cWidth, cHeight, itemImage, 100);
  	graphics.DrawImage(tX, tY, 15, 15, target_image, 100);
  	graphics.DrawImage(0, 0, plugin.window_width, 30, info_image, 100);
  	graphics.DrawText(2, 2, plugin.window_width-2, 28, description, gddColorNormalText, gddTextFlagWordBreak, gddFontNormal);

}

function DrawNotify(item, target, graphics, x, y, width, height)
{
	
}

function DrawMap(x, y)
{
	//convert x and y (given in terms of whole image) into center coordinates of sized image
	var width = plugin.window_width*zoom;
	var height = width/2;

	var iX = x*(width/8192);
	var iY = y*(height/4096);
	

	//find the coordinates of the top left corner of the region
	var xC = parseInt(iX-plugin.window_width/2);
	var yC = parseInt(iY-plugin.window_height/2);
	
	xTop = -xC;
	yTop = -yC;
	
	
	//refresh the display
	contentArea.removeContentItem(map);
	contentArea.addContentItem(map, gddItemDisplayInSidebar);
	
}

function mapIdle()
{
	//this function causes the map to scroll around in a loop when idle
	
	//check to see if idle
	if(CURRENT_LOC != null)
		return;
	
	//return x position to start of the loop
	if(xTop > plugin.window_width)
		xTop = -plugin.window_width;

	var shift = parseInt(plugin.window_width/300);

	if(shift < 1)
	{
		tic+=plugin.window_width/300;
		if(tic > 1)
		{
			shift = parseInt(tic);
			tic = 0;
		}
	}

	xTop+=shift;

	//refresh the display (is there a more effecient way?)
	contentArea.removeContentItem(map);
	contentArea.addContentItem(map, gddItemDisplayInSidebar);
}	

function GetFeeds() {
  var arr = new Array();
  var url = " ";
  for (var i = 0; url != undefined; ++i) {
    url = options("feed_" + i);
    if (url != undefined)
      arr.push(url);
  }
  return arr;
}

function PutUrls(urls) {
  options.removeAll();
  for (var i = 0; i < urls.length; ++i)
    options("feed_" + i) = urls[i];
}

function OnTimer() {

	debug.trace("Timer activated");
  var urls = GetFeeds();
  if(iFeedNum >= urls.length)
	{
	debug.trace("advancing feed");
	iStory++;
	iFeedNum = 0;
	}
	
	iFeedNum++;
	if(!urls[iFeedNum])	
	{
		iFeedNum = 0;
		iStory++;
	}

    var item = new WordItem(urls[iFeedNum]);
    item = null;
	
	if(iStory > 7)
		iStory = 0;

  
}

function TrimString(str) {
  str = str.replace( /^\s+/g, "" );   // strip leading whitespaces
  return str.replace( /\s+$/g, "" );  // strip trailing whitespaces
}

function GetDomainName(url) {
	debug.trace("getting: " + url);
  var i;
  if ((i = url.indexOf("//")) != -1)
    url = url.substring(i + 2);
  if ((i = url.indexOf("/")) != -1)
    url = url.substring(0, i);
  var firstDot = url.indexOf(".");
  var secondDot = url.indexOf(".", firstDot + 1);
  while ((i = url.indexOf(".", secondDot + 1)) != -1) {
    firstDot = secondDot;
    secondDot = i;
  }
  if (firstDot != -1 && secondDot != -1) {
    return url.substring(firstDot + 1);
  }
}

function WordItem(url) {
	if(focused)
		return;

  // send request to webserver for data
  var source = GetDomainName(url);
  var http = new XMLHttpRequest();
	var newsCity = "";
  http.onreadystatechange = OnData;
  http.open("GET", url, true);
  http.send();

  function OnData() {
    if (http.readyState == 4) { // completed?
      // parse the xml data received
      var doc = new DOMDocument();
	var node = null;
      doc.loadXML(http.responseText);

      // read the news title, description and link from the xml
      var title, desc, link, pubDate;
      var elem = doc.getElementsByTagName("item");

	//Test to see if the feed reutrned
      if (elem != null && elem.length > 0) 
		{

		//take the first news story and split it into it's individual elements
        for (node = elem[iStory].firstChild; node != null; node = node.nextSibling) 
		{
          if (node.nodeName == "title")
            title = node.firstChild.nodeValue;
          if (node.nodeName == "description")
            desc = node.firstChild.nodeValue;
          if (node.nodeName == "link")
            link = node.firstChild.nodeValue;
	  if (node.nodeName == "pubDate")
	    pubDate = node.firstChild.nodeValue;
        }

        desc = desc.replace(/<([^>]|\n)*>/g,'');  // remove html tags if present
        desc = desc.replace(/&nbsp;/g, ' ');
        desc = desc.replace(/&quot;/g, '"');
        desc = desc.replace(/&amp;/g, '&');
        
	
	//parse the description to find the city where the news story comes from
        var i = 0;
	i = desc.indexOf(" (");
	newsCity  = desc.substring(0, i);
	newsCity = newsCity.toLowerCase();
          }
       

      	  if (newsCity == null) 
			return; 
          else if (newsCity == CURRENT_LOC)
                return;
	/*
	else if(isInArray(past_news,title))
	{
		debug.trace("Found in past news: " + newsCity);
		return;
	}
	*/
          else
	{
		newsLocation(newsCity);
		debug.trace(desc);
		debug.trace(newsCity);
		if(newsCity == CURRENT_LOC)
			description = newsCity.toUpperCase() + " - " + title;
		map.open_command = link;
		past_news.push(title);
	}

      	http = null;  // free the http object
	}
	
}
}

function OnDetailsView(item) {
  var obj = new Object();
  obj.title = item.heading.substring(0, (item.heading.indexOf(":")));
  // other properties we can set in this object are 'cancel', 'details_control' and
  // 'flags'.
  return obj;
}

function newsLocation(city)
{
	var latC = null;
	var lonC = null;
	
	//find the city in the text database
	var i = 0;
	i = city_list.indexOf(city);
	//if no city is found, do not continue
	if(i==-1)
	{
		timerFailCount++;
		if(timerFailCount < 5)	
			OnTimer();
		else
		{
			setTimeout(OnTimer,1000*30);
		}
		return;
	}
	
	timerFailCount = 0;
	
	var cityValue = city_list.substring(i,i+120);
	var cityArray = cityValue.split(",");
	debug.trace("Latitude: " + cityArray[2]);

	i = cityArray[3].indexOf("\r");
	cityArray[3] = cityArray[3].substring(0, i);

	debug.trace("Longitude: " + cityArray[3]);

	//debug.trace(i);
	
	//record the latitude and longitude of the location
	var lat = cityArray[2].split(" ");
	var lon = cityArray[3].split(" ");
	
	//now convert the latitude and longitude into pixel coordinates on the image
	if(lat[2] == "n")
		latC = parseInt(lat[0])+parseFloat(lat[1]/60);
	if(lat[2] == "s")
		latC = -parseInt(lat[0])-parseFloat(lat[1]/60);
		
	if(lon[2] == "e")
		lonC = parseInt(lon[0])+parseFloat(lon[1]/60);
	if(lon[2] == "w")
		lonC = -parseInt(lon[0])-parseFloat(lon[1]/60);
	
	debug.trace("Lon: " +lonC + " Lat: " + latC);
	if(lonC == null || latC == null)
	{
		OnTimer();
		return;
	}


	CURRENT_LOC = city;

	var y = parseInt(imageHeight - (latC + 90)/.0439);
	var x = parseInt((lonC + 180)*22.757);
	

	debug.trace("Flying to " + x + " " + y);
	
	//city_label.innerText = city;

	focused = true;
	var done  = flyTo(x,y); 
	

	var target = new ContentItem();
	target.heading = "Location";
	
	target.snippet = "";
	
	
	//map.onDrawItem = DrawTarget;
	//map.snippet = city;


}

function mouseOverTarget()
{

}

function flyTo(x,y)
{
	var width = plugin.window_width;
	var height = width/2;

	var Xc = parseInt(8192/(zoom*2)-8192*xTop/(width*zoom));
	var Yc = parseInt(4096/(zoom*2)-4096*yTop/(height*zoom));

	
	//var Xc = plugin.window_width/2-xTop;
	//var Yc = plugin.window_height/2-yTop;

	debug.trace("Current center: " + Xc + ", " + Yc);

	var dX = x-Xc;
	var dY = y-Yc;
	var distance = Math.sqrt(dX*dX+dY*dY);
	

	var iVector = dX/distance;
	var jVector = dY/distance;

	var token = setInterval(movePix, 15);




	//zoom = 15;
	var r = distance/2;
	var dPrime = 0;

	function movePix()
	{
		
		Xc+=parseInt(iVector*20);
		Yc+=parseInt(jVector*20);
		dPrime+=20;
		zoom-=(r-dPrime)/(distance/30)*(1/40);
		if(zoom < 5)
			zoom = 5;
		if(Math.abs(Xc-x)<10)
		{
			Xc = x;
			Yc = y;
			zoom = 15;
			clearInterval(token);
			debug.trace("reaCHED LOCATION");
			moveDone = true;
			map.onDrawItem = DrawTarget;
			setTimeout(clearLocation, 1000*20);
	
		}
		DrawMap(Xc,Yc);


	}
	
	
	/*
	
	zoom = 15;
	DrawMap(x,y);
	
	*/

	//reset after 1 minute
	

	return true;
			
}






function OnDetailsView(item) {
  var obj = new Object();
  obj.title = "Details View";
  // other properties we can set in this object are 'cancel', 'details_control' and
  // 'flags'.
  return obj;
}

function clearLocation()
{
	if(moveDone!=true)
	{
		setTimeout(clearLocation, 1000*10);
		return;
	}
	CURRENT_LOC = null;
	//LoadMap();
	focused = false;
	moveDone = false;
	map.onDrawItem = DrawItem;
	OnTimer();


}

function isInArray(array, string)
{
	for(var i = 0; i < array.length; i++)
	{
		if(string == array[i])
			return true;
	}

	return false;
}